diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/ExportTransformerBase.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/ExportTransformerBase.java
index 2b190669e6..26db2b812f 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/ExportTransformerBase.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/ExportTransformerBase.java
@@ -1,119 +1,120 @@
-/**
-* Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy 
-* http://www.e-taxonomy.eu
-* 
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-
-package eu.etaxonomy.cdm.io.common.mapping.out;
-
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
-
-import eu.etaxonomy.cdm.io.common.mapping.UndefinedTransformerMethodException;
-import eu.etaxonomy.cdm.model.common.ExtensionType;
-import eu.etaxonomy.cdm.model.common.Language;
-import eu.etaxonomy.cdm.model.description.Feature;
-import eu.etaxonomy.cdm.model.description.PresenceAbsenceTerm;
-import eu.etaxonomy.cdm.model.location.NamedArea;
-import eu.etaxonomy.cdm.model.name.NomenclaturalStatusType;
-
-/**
- * @author a.mueller
- * @since 15.03.2010
- * @version 1.0
- */
-public class ExportTransformerBase implements IExportTransformer {
-	@SuppressWarnings("unused")
-	private static final Logger logger = LogManager.getLogger(ExportTransformerBase.class);
-
-	@Override
-	public Object getKeyByFeature(Feature feature) throws UndefinedTransformerMethodException {
-		String warning = "getKeyByFeature is not implemented in implementing transformer class";
-		throw new UndefinedTransformerMethodException(warning);
-	}
-
-	@Override
-	public String getCacheByFeature(Feature feature) throws UndefinedTransformerMethodException {
-		String warning = "getCacheByFeature is not implemented in implementing transformer class";
-		throw new UndefinedTransformerMethodException(warning);
-	}
-
-	@Override
-	public Object getKeyByLanguage(Language language) throws UndefinedTransformerMethodException {
-		String warning = "getKeyByLanguage is not implemented in implementing transformer class";
-		throw new UndefinedTransformerMethodException(warning);
-	}
-	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.io.common.mapping.out.IExportTransformer#getCacheByLanguage(eu.etaxonomy.cdm.model.common.Language)
-	 */
-	@Override
-	public String getCacheByLanguage(Language language) throws UndefinedTransformerMethodException {
-		String warning = "getCacheByLanguage is not implemented in implementing transformer class";
-		throw new UndefinedTransformerMethodException(warning);
-	}
-
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.io.common.mapping.out.IExportTransformer#getKeyByExtensionType(eu.etaxonomy.cdm.model.common.ExtensionType)
-	 */
-	@Override
-	public Object getKeyByExtensionType(ExtensionType extensionType) throws UndefinedTransformerMethodException {
-		String warning = "getKeyByExtensionType is not implemented in implementing transformer class";
-		throw new UndefinedTransformerMethodException(warning);
-	}	@Override
-	public String getCacheByExtensionType(ExtensionType extensionType) throws UndefinedTransformerMethodException {
-		String warning = "getCacheByExtensionType is not implemented in implementing transformer class";
-		throw new UndefinedTransformerMethodException(warning);
-	}
-
-	@Override
-	public Object getKeyByPresenceAbsenceTerm(PresenceAbsenceTerm term) throws UndefinedTransformerMethodException {
-		String warning = "getKeyByPresenceAbsenceTerm is not implemented in implementing transformer class";
-		throw new UndefinedTransformerMethodException(warning);
-	}
-
-	@Override
-	public String getCacheByPresenceAbsenceTerm(PresenceAbsenceTerm term) throws UndefinedTransformerMethodException {
-		String warning = "getKeyByPresenceAbsenceTerm is not implemented in implementing transformer class";
-		throw new UndefinedTransformerMethodException(warning);
-	}
-
-	@Override
-	public Object getKeyByNamedArea(NamedArea area) throws UndefinedTransformerMethodException {
-		String warning = "getKeyByNamedArea is not implemented in implementing transformer class";
-		throw new UndefinedTransformerMethodException(warning);
-	}
-	
-	@Override
-	public String getCacheByNamedArea(NamedArea area) throws UndefinedTransformerMethodException{
-		String warning = "getCacheByNamedArea is not implemented in implementing transformer class";
-		throw new UndefinedTransformerMethodException(warning);
-	}
-	
-	@Override
-	public String getCacheByNomStatus(NomenclaturalStatusType status) throws UndefinedTransformerMethodException {
-		String warning = "getCacheByNomStatus is not implemented in implementing transformer class";
-		throw new UndefinedTransformerMethodException(warning);
-	}
-	
-	
-	@Override
-	public Object getKeyByNomStatus(NomenclaturalStatusType status) throws UndefinedTransformerMethodException {
-		String warning = "getKeyByNomStatus is not yet implemented in implementing transformer class";
-		throw new UndefinedTransformerMethodException(warning);
-	}
-	@Override
-	public String getQualityStatusCacheByKey(Integer qualityStatusFk) throws UndefinedTransformerMethodException {
-		String warning = "getQualityStatusCacheByKey is not yet implemented in implementing transformer class";
-		throw new UndefinedTransformerMethodException(warning);
-	}
-	@Override
-	public String getTaxonStatusCacheByKey(Integer taxonStatusId) throws UndefinedTransformerMethodException {
-		String warning = "getTaxonStatusCacheByKey is not yet implemented in implementing transformer class";
-		throw new UndefinedTransformerMethodException(warning);
-	}
-
-		
-}
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.io.common.mapping.out;
+
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+
+import eu.etaxonomy.cdm.io.common.mapping.UndefinedTransformerMethodException;
+import eu.etaxonomy.cdm.model.common.ExtensionType;
+import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.description.PresenceAbsenceTerm;
+import eu.etaxonomy.cdm.model.location.NamedArea;
+import eu.etaxonomy.cdm.model.name.NomenclaturalStatusType;
+
+/**
+ * @author a.mueller
+ * @since 15.03.2010
+ */
+public class ExportTransformerBase implements IExportTransformer {
+
+	@SuppressWarnings("unused")
+	private static final Logger logger = LogManager.getLogger();
+
+	@Override
+	public Object getKeyByFeature(Feature feature) throws UndefinedTransformerMethodException {
+		String warning = "getKeyByFeature is not implemented in implementing transformer class";
+		throw new UndefinedTransformerMethodException(warning);
+	}
+
+	@Override
+	public String getCacheByFeature(Feature feature) throws UndefinedTransformerMethodException {
+		String warning = "getCacheByFeature is not implemented in implementing transformer class";
+		throw new UndefinedTransformerMethodException(warning);
+	}
+
+	@Override
+	public Object getKeyByLanguage(Language language) throws UndefinedTransformerMethodException {
+		String warning = "getKeyByLanguage is not implemented in implementing transformer class";
+		throw new UndefinedTransformerMethodException(warning);
+	}
+
+	/* (non-Javadoc)
+	 * @see eu.etaxonomy.cdm.io.common.mapping.out.IExportTransformer#getCacheByLanguage(eu.etaxonomy.cdm.model.common.Language)
+	 */
+	@Override
+	public String getCacheByLanguage(Language language) throws UndefinedTransformerMethodException {
+		String warning = "getCacheByLanguage is not implemented in implementing transformer class";
+		throw new UndefinedTransformerMethodException(warning);
+	}
+
+	/* (non-Javadoc)
+	 * @see eu.etaxonomy.cdm.io.common.mapping.out.IExportTransformer#getKeyByExtensionType(eu.etaxonomy.cdm.model.common.ExtensionType)
+	 */
+	@Override
+	public Object getKeyByExtensionType(ExtensionType extensionType) throws UndefinedTransformerMethodException {
+		String warning = "getKeyByExtensionType is not implemented in implementing transformer class";
+		throw new UndefinedTransformerMethodException(warning);
+	}	@Override
+	public String getCacheByExtensionType(ExtensionType extensionType) throws UndefinedTransformerMethodException {
+		String warning = "getCacheByExtensionType is not implemented in implementing transformer class";
+		throw new UndefinedTransformerMethodException(warning);
+	}
+
+	@Override
+	public Object getKeyByPresenceAbsenceTerm(PresenceAbsenceTerm term) throws UndefinedTransformerMethodException {
+		String warning = "getKeyByPresenceAbsenceTerm is not implemented in implementing transformer class";
+		throw new UndefinedTransformerMethodException(warning);
+	}
+
+	@Override
+	public String getCacheByPresenceAbsenceTerm(PresenceAbsenceTerm term) throws UndefinedTransformerMethodException {
+		String warning = "getKeyByPresenceAbsenceTerm is not implemented in implementing transformer class";
+		throw new UndefinedTransformerMethodException(warning);
+	}
+
+	@Override
+	public Object getKeyByNamedArea(NamedArea area) throws UndefinedTransformerMethodException {
+		String warning = "getKeyByNamedArea is not implemented in implementing transformer class";
+		throw new UndefinedTransformerMethodException(warning);
+	}
+
+	@Override
+	public String getCacheByNamedArea(NamedArea area) throws UndefinedTransformerMethodException{
+		String warning = "getCacheByNamedArea is not implemented in implementing transformer class";
+		throw new UndefinedTransformerMethodException(warning);
+	}
+
+	@Override
+	public String getCacheByNomStatus(NomenclaturalStatusType status) throws UndefinedTransformerMethodException {
+		String warning = "getCacheByNomStatus is not implemented in implementing transformer class";
+		throw new UndefinedTransformerMethodException(warning);
+	}
+
+
+	@Override
+	public Object getKeyByNomStatus(NomenclaturalStatusType status) throws UndefinedTransformerMethodException {
+		String warning = "getKeyByNomStatus is not yet implemented in implementing transformer class";
+		throw new UndefinedTransformerMethodException(warning);
+	}
+	@Override
+	public String getQualityStatusCacheByKey(Integer qualityStatusFk) throws UndefinedTransformerMethodException {
+		String warning = "getQualityStatusCacheByKey is not yet implemented in implementing transformer class";
+		throw new UndefinedTransformerMethodException(warning);
+	}
+	@Override
+	public String getTaxonStatusCacheByKey(Integer taxonStatusId) throws UndefinedTransformerMethodException {
+		String warning = "getTaxonStatusCacheByKey is not yet implemented in implementing transformer class";
+		throw new UndefinedTransformerMethodException(warning);
+	}
+
+
+}
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/IdIncMapper.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/IdIncMapper.java
index b31e60802d..08e129f37e 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/IdIncMapper.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/IdIncMapper.java
@@ -11,7 +11,8 @@ package eu.etaxonomy.cdm.io.common.mapping.out;
 
 import java.sql.Types;
 
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
 
 import eu.etaxonomy.cdm.io.common.DbExportStateBase;
 import eu.etaxonomy.cdm.io.common.Source;
@@ -29,7 +30,7 @@ public class IdIncMapper
         implements IDbExportMapper<DbExportStateBase<?, IExportTransformer>, IExportTransformer>{
 
     @SuppressWarnings("unused")
-    private static final Logger logger = LogManager.getLogger(IdIncMapper.class);
+    private static final Logger logger = LogManager.getLogger();
 
     private Integer startValue;
     private IndexCounter counter;
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/IdMapper.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/IdMapper.java
index f39ab8de38..7e46b5c2f8 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/IdMapper.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/IdMapper.java
@@ -12,7 +12,8 @@ package eu.etaxonomy.cdm.io.common.mapping.out;
 import java.sql.SQLException;
 import java.sql.Types;
 
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
 
 import eu.etaxonomy.cdm.io.common.DbExportConfiguratorBase.IdType;
 import eu.etaxonomy.cdm.io.common.DbExportStateBase;
@@ -28,7 +29,7 @@ public class IdMapper
         extends DbSingleAttributeExportMapperBase<DbExportStateBase<?, IExportTransformer>>
         implements IDbExportMapper<DbExportStateBase<?, IExportTransformer>, IExportTransformer>{
 
-    private static final Logger logger = LogManager.getLogger(IdMapper.class);
+    private static final Logger logger = LogManager.getLogger();
 
 	public static IdMapper NewInstance(String dbIdAttributeString){
 		return new IdMapper(dbIdAttributeString);
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/IndexCounter.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/IndexCounter.java
index 109de884c4..25141886ea 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/IndexCounter.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/IndexCounter.java
@@ -1,41 +1,43 @@
-/**
-* Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-
-package eu.etaxonomy.cdm.io.common.mapping.out;
-
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
-
-/**
- * @author a.mueller
- * @since 12.05.2009
- */
-public class IndexCounter {
-	@SuppressWarnings("unused")
-	private static final Logger logger = LogManager.getLogger(IndexCounter.class);
-
-	int index = 0;
-
-	public IndexCounter(int startValue){
-		index = startValue;
-	}
-
-	/**
-	 * Returns the index and increases it by 1
-	 * @return
-	 */
-	public int getIncreasing(){
-		return index++;
-	}
-
-	@Override
-    public String toString(){
-		return String.valueOf(index);
-	}
-
-}
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.io.common.mapping.out;
+
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+
+/**
+ * @author a.mueller
+ * @since 12.05.2009
+ */
+public class IndexCounter {
+
+	@SuppressWarnings("unused")
+	private static final Logger logger = LogManager.getLogger();
+
+	int index = 0;
+
+	public IndexCounter(int startValue){
+		index = startValue;
+	}
+
+	/**
+	 * Returns the index and increases it by 1
+	 * @return
+	 */
+	public int getIncreasing(){
+		return index++;
+	}
+
+	@Override
+    public String toString(){
+		return String.valueOf(index);
+	}
+
+}
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/MethodMapper.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/MethodMapper.java
index f09e1a64c5..ace4316d5b 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/MethodMapper.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/common/mapping/out/MethodMapper.java
@@ -1,127 +1,128 @@
-/**
-* Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-
-package eu.etaxonomy.cdm.io.common.mapping.out;
-
-import java.lang.reflect.InvocationTargetException;
-import java.lang.reflect.Method;
-import java.sql.Types;
-
-import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;
-import org.joda.time.DateTime;
-
-import eu.etaxonomy.cdm.io.common.DbExportBase;
-import eu.etaxonomy.cdm.io.common.DbExportStateBase;
-import eu.etaxonomy.cdm.model.common.CdmBase;
-
-/**
- * @author a.mueller
- * @since 12.05.2009
- */
-public class MethodMapper
-            extends DbSingleAttributeExportMapperBase<DbExportStateBase<?, IExportTransformer>>
-            implements IDbExportMapper<DbExportStateBase<?, IExportTransformer>, IExportTransformer> {
-
-    private static final Logger logger = LogManager.getLogger(MethodMapper.class);
-
-	private Method method;
-	private Class<?>[] parameterTypes;
-
-	public static <T extends DbExportBase> MethodMapper NewInstance(String dbAttributeString, DbExportBase exportBase){
-		String methodName = getMethodName(dbAttributeString);
-		return NewInstance(dbAttributeString, exportBase, methodName);
-	}
-
-	public static <T extends DbExportBase> MethodMapper NewInstance(String dbAttributeString, DbExportBase exportBase, Class<?>... parameterTypes){
-		String methodName = getMethodName(dbAttributeString);
-		return new MethodMapper(dbAttributeString, exportBase.getClass(), methodName, parameterTypes);
-	}
-
-	public static <T extends DbExportBase> MethodMapper NewInstance(String dbAttributeString, DbExportBase exportBase, String methodName){
-		Class<?> parameterTypes = exportBase.getStandardMethodParameter();
-		MethodMapper result = new MethodMapper(dbAttributeString, exportBase.getClass(), methodName, parameterTypes);
-		return result;
-	}
-
-	public static <T extends DbExportBase> MethodMapper NewInstance(String dbAttributeString, Class<?> clazz, Class<?>... parameterTypes){
-	    String methodName = getMethodName(dbAttributeString);
-        MethodMapper result = new MethodMapper(dbAttributeString, clazz, methodName, parameterTypes);
-        return result;
-    }
-
-	public static <T extends DbExportBase> MethodMapper NewInstance(String dbAttributeString, Class<?> clazz, String methodName, Class<?>... parameterTypes){
-		MethodMapper result = new MethodMapper(dbAttributeString, clazz, methodName, parameterTypes);
-		return result;
-	}
-
-	public static <T extends DbExportBase> MethodMapper NewInstance(String dbAttributeString, Class<?> clazz, String methodName, Class<?> parameterType1, Class<?> parameterType2){
-		MethodMapper result = new MethodMapper(dbAttributeString, clazz, methodName, parameterType1, parameterType2);
-		return result;
-	}
-
-	protected MethodMapper(String dbAttributeString, Class<?> clazz, String methodName, Class<?>... parameterTypes) {
-		super(null, dbAttributeString, null);
-		try {
-			this.parameterTypes = parameterTypes;
-			method = clazz.getDeclaredMethod(methodName, parameterTypes);
-			method.setAccessible(true);
-		} catch (SecurityException e) {
-			logger.error("SecurityException", e);
-		} catch (NoSuchMethodException e) {
-			logger.error("NoSuchMethodException", e);
-		}
-	}
-
-    private static String getMethodName(String dbAttributeString) {
-        String methodName = "get" + dbAttributeString;
-        return methodName;
-    }
-
-	@Override
-	public Class<?> getTypeClass() {
-		return method.getReturnType();
-	}
-
-	@Override
-	protected Object getValue(CdmBase cdmBase) {
-		try{
-			if (this.parameterTypes.length > 1 && DbExportStateBase.class.isAssignableFrom(parameterTypes[1])){
-				return method.invoke(null, cdmBase, getState());
-			}else{
-				return method.invoke(null, cdmBase);
-			}
-		} catch (IllegalAccessException e) {
-			logger.error("IllegalAccessException: " + e.getMessage() + " when invoking MethodMapper " +  this.toString());
-			throw new RuntimeException(e);
-		} catch (InvocationTargetException e) {
-			logger.error("InvocationTargetException: " + e.getMessage() + " when invoking MethodMapper " +  this.toString());
-			throw new RuntimeException(e);
-		} catch (Exception e) {
-			logger.error("Any Exception: " + e.getMessage() + " when invoking MethodMapper " +  this.toString());
-			throw new RuntimeException(e);
-		}
-	}
-
-	@Override
-	protected int getSqlType() {
-		Class<?> returnType = method.getReturnType();
-		if (returnType == Integer.class){
-			return Types.INTEGER;
-		}else if (returnType == String.class){
-			return Types.VARCHAR;
-		}else if (returnType == Boolean.class){
-			return Types.BOOLEAN;
-		}else if (returnType == DateTime.class){
-			return Types.DATE;
-		}else{
-			logger.warn("Return type not supported yet: " + returnType.getSimpleName());
-			throw new IllegalArgumentException("Return type not supported yet: " + returnType.getSimpleName());
-		}
-	}
-}
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.io.common.mapping.out;
+
+import java.lang.reflect.InvocationTargetException;
+import java.lang.reflect.Method;
+import java.sql.Types;
+
+import org.apache.logging.log4j.LogManager;
+import org.apache.logging.log4j.Logger;
+import org.joda.time.DateTime;
+
+import eu.etaxonomy.cdm.io.common.DbExportBase;
+import eu.etaxonomy.cdm.io.common.DbExportStateBase;
+import eu.etaxonomy.cdm.model.common.CdmBase;
+
+/**
+ * @author a.mueller
+ * @since 12.05.2009
+ */
+public class MethodMapper
+            extends DbSingleAttributeExportMapperBase<DbExportStateBase<?, IExportTransformer>>
+            implements IDbExportMapper<DbExportStateBase<?, IExportTransformer>, IExportTransformer> {
+
+    private static final Logger logger = LogManager.getLogger();
+
+	private Method method;
+	private Class<?>[] parameterTypes;
+
+	public static <T extends DbExportBase> MethodMapper NewInstance(String dbAttributeString, DbExportBase exportBase){
+		String methodName = getMethodName(dbAttributeString);
+		return NewInstance(dbAttributeString, exportBase, methodName);
+	}
+
+	public static <T extends DbExportBase> MethodMapper NewInstance(String dbAttributeString, DbExportBase exportBase, Class<?>... parameterTypes){
+		String methodName = getMethodName(dbAttributeString);
+		return new MethodMapper(dbAttributeString, exportBase.getClass(), methodName, parameterTypes);
+	}
+
+	public static <T extends DbExportBase> MethodMapper NewInstance(String dbAttributeString, DbExportBase exportBase, String methodName){
+		Class<?> parameterTypes = exportBase.getStandardMethodParameter();
+		MethodMapper result = new MethodMapper(dbAttributeString, exportBase.getClass(), methodName, parameterTypes);
+		return result;
+	}
+
+	public static <T extends DbExportBase> MethodMapper NewInstance(String dbAttributeString, Class<?> clazz, Class<?>... parameterTypes){
+	    String methodName = getMethodName(dbAttributeString);
+        MethodMapper result = new MethodMapper(dbAttributeString, clazz, methodName, parameterTypes);
+        return result;
+    }
+
+	public static <T extends DbExportBase> MethodMapper NewInstance(String dbAttributeString, Class<?> clazz, String methodName, Class<?>... parameterTypes){
+		MethodMapper result = new MethodMapper(dbAttributeString, clazz, methodName, parameterTypes);
+		return result;
+	}
+
+	public static <T extends DbExportBase> MethodMapper NewInstance(String dbAttributeString, Class<?> clazz, String methodName, Class<?> parameterType1, Class<?> parameterType2){
+		MethodMapper result = new MethodMapper(dbAttributeString, clazz, methodName, parameterType1, parameterType2);
+		return result;
+	}
+
+	protected MethodMapper(String dbAttributeString, Class<?> clazz, String methodName, Class<?>... parameterTypes) {
+		super(null, dbAttributeString, null);
+		try {
+			this.parameterTypes = parameterTypes;
+			method = clazz.getDeclaredMethod(methodName, parameterTypes);
+			method.setAccessible(true);
+		} catch (SecurityException e) {
+			logger.error("SecurityException", e);
+		} catch (NoSuchMethodException e) {
+			logger.error("NoSuchMethodException", e);
+		}
+	}
+
+    private static String getMethodName(String dbAttributeString) {
+        String methodName = "get" + dbAttributeString;
+        return methodName;
+    }
+
+	@Override
+	public Class<?> getTypeClass() {
+		return method.getReturnType();
+	}
+
+	@Override
+	protected Object getValue(CdmBase cdmBase) {
+		try{
+			if (this.parameterTypes.length > 1 && DbExportStateBase.class.isAssignableFrom(parameterTypes[1])){
+				return method.invoke(null, cdmBase, getState());
+			}else{
+				return method.invoke(null, cdmBase);
+			}
+		} catch (IllegalAccessException e) {
+			logger.error("IllegalAccessException: " + e.getMessage() + " when invoking MethodMapper " +  this.toString());
+			throw new RuntimeException(e);
+		} catch (InvocationTargetException e) {
+			logger.error("InvocationTargetException: " + e.getMessage() + " when invoking MethodMapper " +  this.toString());
+			throw new RuntimeException(e);
+		} catch (Exception e) {
+			logger.error("Any Exception: " + e.getMessage() + " when invoking MethodMapper " +  this.toString());
+			throw new RuntimeException(e);
+		}
+	}
+
+	@Override
+	protected int getSqlType() {
+		Class<?> returnType = method.getReturnType();
+		if (returnType == Integer.class){
+			return Types.INTEGER;
+		}else if (returnType == String.class){
+			return Types.VARCHAR;
+		}else if (returnType == Boolean.class){
+			return Types.BOOLEAN;
+		}else if (returnType == DateTime.class){
+			return Types.DATE;
+		}else{
+			logger.warn("Return type not supported yet: " + returnType.getSimpleName());
+			throw new IllegalArgumentException("Return type not supported yet: " + returnType.getSimpleName());
+		}
+	}
+}
